﻿using UnityEngine;
using System.Collections;

public class CeilingTransparency : MonoBehaviour {

	private bool fadingIn  = false;
	private bool fadingOut = false;
	[SerializeField] private float fadeTime = 1;
	private float fadeCounter;

	private Color opaqueColor;
	private Color transparentColor;

	private void Awake()
	{
		opaqueColor      = renderer.material.color;
		transparentColor = renderer.material.color;
		opaqueColor     .a = 1;
		transparentColor.a = 0;
		Debug.Log (opaqueColor);
		Debug.Log (transparentColor);
	}

	private void OnTriggerEnter(Collider collision)
	{
		if (collision.name.StartsWith ("Player"))
		{
			fadingIn = true;
			if (fadingOut)
			{
				fadingOut = false;
				fadeCounter = fadeTime - fadeCounter;
			}
			else fadeCounter = 0;
		}
	}

	private void OnTriggerExit(Collider collision)
	{
		if (collision.name.StartsWith ("Player"))
		{
			fadingOut = true;
			if (fadingIn)
			{
				fadingIn = false;
				fadeCounter = fadeTime - fadeCounter;
			}
			else fadeCounter = 0;
		}
	}

	private void Update()
	{
		if (!fadingIn && !fadingOut) return;
		fadeCounter += Time.deltaTime;
		if (fadingIn)
		{
			renderer.material.color = Color.Lerp(opaqueColor, transparentColor, fadeCounter / fadeTime);
		}
		else if (fadingOut)
		{
			renderer.material.color = Color.Lerp(transparentColor, opaqueColor, fadeCounter / fadeTime);
		}
		if (fadeCounter > fadeTime)
		{
			fadingIn = false;
			fadingOut = false;
		}
	}
}
