﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System;

public class CooldownController : MonoBehaviour {

	protected Image myImage;
	protected float cooldown;
	protected float cooldownCounter;
	protected Action onCooldownEnd;
	protected IntDelegate onCooldownEndInt;
	protected int parameter;
	[SerializeField] protected float defaultCooldown = 2;
	[SerializeField] protected Spell spellEffect;

	virtual protected void Awake()
	{
		myImage = this.GetComponent<Image> ();
		if (myImage == null)
		{
			Debug.LogWarning("El objeto " + this.name + " no tiene Image para supervisar con VistaDeCooldown");
			GameObject.Destroy(this.gameObject);
		}
	}

	virtual public void UseEffect(float _cooldown, Action _onCooldownEnd)
	{
		onCooldownEnd = _onCooldownEnd;
		cooldown = _cooldown;
		cooldownCounter = cooldown;
	}

	virtual public void UseEffect(IntDelegate _onCooldownEnd, int _parameter)
	{
		onCooldownEndInt = _onCooldownEnd;
		parameter = _parameter;
		cooldown = spellEffect.cooldown;
		cooldownCounter = cooldown;
		spellEffect.Cast();
	}

	// Update is called once per frame
	virtual protected void Update ()
	{
		if (cooldownCounter > 0)
		{
			cooldownCounter -= Time.deltaTime;
			if (cooldownCounter <= 0)
			{
				cooldownCounter = 0;
				if (onCooldownEnd != null) onCooldownEnd();
				else if (onCooldownEndInt != null) onCooldownEndInt(parameter);

				onCooldownEnd = null;
				onCooldownEndInt = null;
			}
			myImage.fillAmount = cooldownCounter / cooldown;
		}
	}
}
