﻿using UnityEngine;
using System.Collections;

public class HealSpell : Spell {

	[SerializeField] private int healAmount;
	private int loopDuration;

	public override void Cast ()
	{
		StartCoroutine(Heal());
	}

	private IEnumerator Heal()
	{
		loopDuration = Mathf.RoundToInt(power);
		do
		{
			PlayerController.Heal(healAmount);
			loopDuration--;
			yield return new WaitForSeconds(1);
		} while (loopDuration > 0);
	}

}
