﻿using UnityEngine;
using System.Collections;
using System;

public class Spell : MonoBehaviour {

	public enum Type
	{
		Fire,
		Electric,
		Ground,
		Clock,
		Water,
		Wind
	}
	
	[SerializeField] protected float minimumPower;
	[SerializeField] protected float maximumPower;
	public float power;
	[SerializeField] protected float baseCooldown = 1;

	protected bool setPowerManually = false;

	public float cooldown
	{
		get
		{
			float ratio = (((float)power - (float)minimumPower) / ((float)maximumPower - (float)minimumPower));
			ratio += 0.5f;
			return (float)baseCooldown * ratio;
		}
	}

	public float spellPower
	{
		get { return power; }
	}

	protected void Awake()
	{
		if (setPowerManually) return;
		power = Mathf.Round(UnityEngine.Random.Range(minimumPower, maximumPower));
	}

	virtual public void Cast() {}
}
